Index: arch/mips/ddb5xxx/ddb5074/pci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5074/pci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5074/pci.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5074/pci.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -9,22 +9,24 @@
 #include <asm/ddb5xxx/ddb5xxx.h>
 
 static struct resource extpci_io_resource = {
-    "pci IO space",
-    0x1000,             /* leave some room for ISA bus */
-    DDB_PCI_IO_SIZE -1,
-    IORESOURCE_IO};
+	"pci IO space",
+	0x1000,			/* leave some room for ISA bus */
+	DDB_PCI_IO_SIZE - 1,
+	IORESOURCE_IO
+};
 
 static struct resource extpci_mem_resource = {
-    "pci memory space",
-    DDB_PCI_MEM_BASE + 0x00100000,  /* leave 1 MB for RTC */
-    DDB_PCI_MEM_BASE + DDB_PCI_MEM_SIZE -1,
-    IORESOURCE_MEM};
+	"pci memory space",
+	DDB_PCI_MEM_BASE + 0x00100000,	/* leave 1 MB for RTC */
+	DDB_PCI_MEM_BASE + DDB_PCI_MEM_SIZE - 1,
+	IORESOURCE_MEM
+};
 
 extern struct pci_ops ddb5476_ext_pci_ops;
 
 struct pci_channel mips_pci_channels[] = {
-    { &ddb5476_ext_pci_ops, &extpci_io_resource, &extpci_mem_resource },
-    { NULL, NULL, NULL}
+	{&ddb5476_ext_pci_ops, &extpci_io_resource, &extpci_mem_resource},
+	{NULL, NULL, NULL}
 };
 
 #define     PCI_EXT_INTA        8
@@ -52,7 +54,8 @@
 	/* SLOT:  13 */ nile4_to_irq(PCI_EXT_INTE),
 };
 
-void __init pcibios_fixup_irqs(void) {
+void __init pcibios_fixup_irqs(void)
+{
 
 	struct pci_dev *dev;
 	int slot_num;
@@ -60,12 +63,12 @@
 	pci_for_each_dev(dev) {
 		slot_num = PCI_SLOT(dev->devfn);
 		db_assert(slot_num < MAX_SLOT_NUM);
-printk("irq_map[%d]: %02x\n",slot_num, irq_map[slot_num]);
+		printk("irq_map[%d]: %02x\n", slot_num, irq_map[slot_num]);
 		db_assert(irq_map[slot_num] != 0xff);
 
 		pci_write_config_byte(dev,
-							PCI_INTERRUPT_LINE,
-							irq_map[slot_num]);
+				      PCI_INTERRUPT_LINE,
+				      irq_map[slot_num]);
 
 		dev->irq = irq_map[slot_num];
 	}
@@ -73,27 +76,27 @@
 
 void __init ddb_pci_reset_bus(void)
 {
-    u32 temp;
+	u32 temp;
 
-    /*
-     * I am not sure about the "official" procedure, the following
-     * steps work as far as I know:
-     * We first set PCI cold reset bit (bit 31) in PCICTRL-H.
-     * Then we clear the PCI warm reset bit (bit 30) to 0 in PCICTRL-H.
-     * The same is true for both PCI channels.
-     */
-    temp = ddb_in32(DDB_PCICTRL+4);
-    temp |= 0x80000000;
-    ddb_out32(DDB_PCICTRL+4, temp);
-    temp &= ~0xc0000000;
-    ddb_out32(DDB_PCICTRL+4, temp);
+	/*
+	 * I am not sure about the "official" procedure, the following
+	 * steps work as far as I know:
+	 * We first set PCI cold reset bit (bit 31) in PCICTRL-H.
+	 * Then we clear the PCI warm reset bit (bit 30) to 0 in PCICTRL-H.
+	 * The same is true for both PCI channels.
+	 */
+	temp = ddb_in32(DDB_PCICTRL + 4);
+	temp |= 0x80000000;
+	ddb_out32(DDB_PCICTRL + 4, temp);
+	temp &= ~0xc0000000;
+	ddb_out32(DDB_PCICTRL + 4, temp);
 
 }
 
 unsigned __init int pcibios_assign_all_busses(void)
 {
-    /* we hope pci_auto has assigned the bus numbers to all buses */
-    return 1;
+	/* we hope pci_auto has assigned the bus numbers to all buses */
+	return 1;
 }
 
 void __init pcibios_fixup_resources(struct pci_dev *dev)
@@ -106,25 +109,24 @@
 
 	pci_for_each_dev(dev) {
 		if (dev->vendor == PCI_VENDOR_ID_AL &&
-			dev->device == PCI_DEVICE_ID_AL_M7101) {
-				/*
-				 * It's nice to have the LEDs on the GPIO pins
-				 * available for debugging
-				 */
-				extern struct pci_dev *pci_pmu;
-				u8 t8;
-
-				pci_pmu = dev;  /* for LEDs D2 and D3 */
-				/* Program the lines for LEDs D2 and D3 to output */
-				pci_read_config_byte(dev, 0x7d, &t8);
-				t8 |= 0xc0;
-				pci_write_config_byte(dev, 0x7d, t8);
-				/* Turn LEDs D2 and D3 off */
-				pci_read_config_byte(dev, 0x7e, &t8);
-				t8 |= 0xc0;
-				pci_write_config_byte(dev, 0x7e, t8);
+		    dev->device == PCI_DEVICE_ID_AL_M7101) {
+			/*
+			 * It's nice to have the LEDs on the GPIO pins
+			 * available for debugging
+			 */
+			extern struct pci_dev *pci_pmu;
+			u8 t8;
+
+			pci_pmu = dev;	/* for LEDs D2 and D3 */
+			/* Program the lines for LEDs D2 and D3 to output */
+			pci_read_config_byte(dev, 0x7d, &t8);
+			t8 |= 0xc0;
+			pci_write_config_byte(dev, 0x7d, t8);
+			/* Turn LEDs D2 and D3 off */
+			pci_read_config_byte(dev, 0x7e, &t8);
+			t8 |= 0xc0;
+			pci_write_config_byte(dev, 0x7e, t8);
 
 		}
 	}
 }
-
Index: arch/mips/ddb5xxx/ddb5074/pci_ops.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5074/pci_ops.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5074/pci_ops.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5074/pci_ops.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -49,8 +49,6 @@
 	DDB_PCI_CONFIG_SIZE
 };
 
-static int pci_config_workaround=1;
-
 /*
  * access config space
  */
@@ -63,12 +61,8 @@
         u32 virt_addr = swap->config_base;
 	u32 option;
 
-	if (pci_config_workaround) {
-		if (slot_num == 5) slot_num = 14;
-	}
-	else {
-		if (slot_num == 5) return DDB_BASE + DDB_PCI_BASE;
-	}
+	if (slot_num == 5)
+		slot_num = 14;
 
 	/* minimum pdar (window) size is 2MB */
 	db_assert(swap->config_size >= (2 << 20));
@@ -279,64 +273,3 @@
 	extpci_write_config_word,
 	extpci_write_config_dword
 };
-
-
-#if defined(CONFIG_DEBUG)
-void jsun_scan_pci_bus(void)
-{
-	struct pci_bus bus;
-	struct pci_dev dev;
-	unsigned int devfn;
-	int j;
-
-	pci_config_workaround = 0;
-
-	bus.parent = NULL;	/* we scan the top level only */
-	dev.bus = &bus;
-	dev.sysdata = NULL;
-
-	/* scan ext pci bus and io pci bus*/
-	for (j=0; j< 1; j++) {
-		printk(KERN_INFO "scan ddb5476 external PCI bus:\n");
-		bus.ops = &ddb5476_ext_pci_ops;
-
-		for (devfn = 0; devfn < 0x100; devfn += 8) {
-			u32 temp;
-			u16 temp16;
-			u8 temp8;
-			int i;
-
-			dev.devfn = devfn;
-			db_verify(pci_read_config_dword(&dev, 0, &temp),
-				    == PCIBIOS_SUCCESSFUL);
-			if (temp == 0xffffffff) continue;
-
-			printk(KERN_INFO "slot %d: (addr %d) \n", devfn/8,
-			       11+devfn/8);
-
-			/* verify read word and byte */
-			db_verify(pci_read_config_word(&dev, 2, &temp16),
-				  == PCIBIOS_SUCCESSFUL);
-			db_assert(temp16 == (temp >> 16));
-			db_verify(pci_read_config_byte(&dev, 3, &temp8),
-				  == PCIBIOS_SUCCESSFUL);
-			db_assert(temp8 == (temp >> 24));
-			db_verify(pci_read_config_byte(&dev, 1, &temp8),
-				  == PCIBIOS_SUCCESSFUL);
-			db_assert(temp8 == ((temp >> 8) & 0xff));
-
-			for (i=0; i < 16; i++) {
-				if ((i%4) == 0)
-					printk(KERN_INFO);
-				db_verify(pci_read_config_dword(&dev, i*4, &temp),
-					  == PCIBIOS_SUCCESSFUL);
-				printk("\t%08X", temp);
-				if ((i%4) == 3)
-					printk("\n");
-			}
-		}
-	}
-
-	pci_config_workaround = 1;
-}
-#endif
Index: arch/mips/ddb5xxx/ddb5074/setup.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5074/setup.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5074/setup.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5074/setup.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -31,15 +31,11 @@
 #include <asm/ddb5xxx/ddb5xxx.h>
 
 
-#ifdef CONFIG_REMOTE_DEBUG
+#ifdef CONFIG_KGDB
 extern void rs_kgdb_hook(int);
 extern void breakpoint(void);
 #endif
 
-#if defined(CONFIG_SERIAL_CONSOLE)
-extern void console_setup(char *);
-#endif
-
 extern struct ide_ops std_ide_ops;
 extern struct kbd_ops std_kbd_ops;
 extern struct rtc_ops ddb_rtc_ops;
@@ -81,10 +77,6 @@
 
 extern void (*board_timer_setup) (struct irqaction * irq);
 
-void __init bus_error_init(void)
-{
-}
-
 static void __init ddb_timer_init(struct irqaction *irq)
 {
 	/* set the clock to 1 Hz */
@@ -96,7 +88,7 @@
 	/* enable interrupt */
 	setup_irq(nile4_to_irq(NILE4_INT_GPT), irq);
 	nile4_enable_irq(nile4_to_irq(NILE4_INT_GPT));
-	change_cp0_status(ST0_IM,
+	change_c0_status(ST0_IM,
 		          IE_IRQ0 | IE_IRQ1 | IE_IRQ2 | IE_IRQ3 | IE_IRQ4);
 
 }
Index: arch/mips/ddb5xxx/ddb5476/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/Makefile	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/Makefile	4 Aug 2004 01:25:49 -0000	1.2
@@ -15,6 +15,6 @@
 
 obj-y				+= setup.o irq.o int-handler.o pci.o pci_ops.o \
 				   nile4_pic.o vrc5476_irq.o
-obj-$(CONFIG_REMOTE_DEBUG)	+= dbg_io.o
+obj-$(CONFIG_KGDB)	+= dbg_io.o
 
 include $(TOPDIR)/Rules.make
Index: arch/mips/ddb5xxx/ddb5476/irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/irq.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/irq.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/irq.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -14,6 +14,7 @@
 #include <linux/types.h>
 #include <linux/interrupt.h>
 
+#include <asm/i8259.h>
 #include <asm/io.h>
 #include <asm/ptrace.h>
 
Index: arch/mips/ddb5xxx/ddb5476/nile4_pic.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/nile4_pic.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/nile4_pic.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/nile4_pic.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -163,7 +163,7 @@
 	return irq + I8259_IRQ_BASE;
 }
 
-#if defined(CONFIG_LL_DEBUG)
+#if defined(CONFIG_RUNTIME_DEBUG)
 void nile4_dump_irq_status(void)
 {
 	printk(KERN_DEBUG "
Index: arch/mips/ddb5xxx/ddb5476/pci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/pci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/pci.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/pci.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -100,10 +100,6 @@
 	}
 }
 
-#if defined(CONFIG_DEBUG)
-extern void jsun_scan_pci_bus(void);
-#endif
-
 void __init ddb_pci_reset_bus(void)
 {
 	u32 temp;
Index: arch/mips/ddb5xxx/ddb5476/pci_ops.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/pci_ops.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/pci_ops.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/pci_ops.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -49,8 +49,6 @@
 	DDB_PCI_CONFIG_SIZE
 };
 
-static int pci_config_workaround=1;
-
 /*
  * access config space
  */
@@ -63,27 +61,11 @@
         u32 virt_addr = swap->config_base;
 	u32 option;
 
-	if (pci_config_workaround) {
-		/* [jsun] work around Vrc5476 controller itself, returnning
-		 * slot 0 essentially makes vrc5476 invisible
-		 */
-		if (slot_num == 12) slot_num = 0;
-
-#if 0
-		/* BUG : skip P2P bridge for now */
-		if (slot_num == 5) slot_num = 0;
-#endif
-
-	} else {
-		/* now we have to be hornest, returning the true
-		 * PCI config headers for vrc5476
-		 */
-		if (slot_num == 12) {
-			swap->pdar_backup = ddb_in32(swap->pdar);
-			swap->pmr_backup = ddb_in32(swap->pmr);
-			return DDB_BASE + DDB_PCI_BASE;
-		}
-	}
+	/*
+	 * BUG: skip host PCI controller.  Its BARS are bogus.
+	 */
+	if (slot_num == 12)
+		slot_num = 0;
 
 	/* minimum pdar (window) size is 2MB */
 	db_assert(swap->config_size >= (2 << 20));
@@ -294,64 +276,3 @@
 	extpci_write_config_word,
 	extpci_write_config_dword
 };
-
-
-#if defined(CONFIG_DEBUG)
-void jsun_scan_pci_bus(void)
-{
-	struct pci_bus bus;
-	struct pci_dev dev;
-	unsigned int devfn;
-	int j;
-
-	pci_config_workaround = 0;
-
-	bus.parent = NULL;	/* we scan the top level only */
-	dev.bus = &bus;
-	dev.sysdata = NULL;
-
-	/* scan ext pci bus and io pci bus*/
-	for (j=0; j< 1; j++) {
-		printk(KERN_INFO "scan ddb5476 external PCI bus:\n");
-		bus.ops = &ddb5476_ext_pci_ops;
-
-		for (devfn = 0; devfn < 0x100; devfn += 8) {
-			u32 temp;
-			u16 temp16;
-			u8 temp8;
-			int i;
-
-			dev.devfn = devfn;
-			db_verify(pci_read_config_dword(&dev, 0, &temp),
-				    == PCIBIOS_SUCCESSFUL);
-			if (temp == 0xffffffff) continue;
-
-			printk(KERN_INFO "slot %d: (addr %d) \n", devfn/8,
-			       11+devfn/8);
-
-			/* verify read word and byte */
-			db_verify(pci_read_config_word(&dev, 2, &temp16),
-				  == PCIBIOS_SUCCESSFUL);
-			db_assert(temp16 == (temp >> 16));
-			db_verify(pci_read_config_byte(&dev, 3, &temp8),
-				  == PCIBIOS_SUCCESSFUL);
-			db_assert(temp8 == (temp >> 24));
-			db_verify(pci_read_config_byte(&dev, 1, &temp8),
-				  == PCIBIOS_SUCCESSFUL);
-			db_assert(temp8 == ((temp >> 8) & 0xff));
-
-			for (i=0; i < 16; i++) {
-				if ((i%4) == 0)
-					printk(KERN_INFO);
-				db_verify(pci_read_config_dword(&dev, i*4, &temp),
-					  == PCIBIOS_SUCCESSFUL);
-				printk("\t%08X", temp);
-				if ((i%4) == 3)
-					printk("\n");
-			}
-		}
-	}
-
-	pci_config_workaround = 1;
-}
-#endif
Index: arch/mips/ddb5xxx/ddb5476/setup.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/setup.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/setup.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/setup.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -41,7 +41,7 @@
 #define TIMER_IRQ			(VRC5476_IRQ_BASE + VRC5476_IRQ_GPT)
 #endif
 
-#ifdef CONFIG_REMOTE_DEBUG
+#ifdef CONFIG_KGDB
 extern void breakpoint(void);
 #endif
 
@@ -84,7 +84,7 @@
 static void __init ddb_time_init(void)
 {
 #if defined(USE_CPU_COUNTER_TIMER)
-	mips_counter_frequency = CPU_COUNTER_FREQUENCY;
+	mips_hpt_frequency = CPU_COUNTER_FREQUENCY;
 #endif
 
 	/* we have ds1396 RTC chip */
@@ -103,8 +103,8 @@
 	setup_irq(CPU_IRQ_BASE + 7, irq);
 
 	/* to generate the first timer interrupt */
-	count = read_32bit_cp0_register(CP0_COUNT);
-	write_32bit_cp0_register(CP0_COMPARE, count + 1000);
+	count = read_c0_count();
+	write_c0_compare(count + 1000);
 
 #else
 
@@ -140,9 +140,6 @@
 };
 
 
-void __init bus_error_init(void) { /* nothing */ }
-
-
 static void ddb5476_board_init(void);
 extern void ddb5476_irq_setup(void);
 extern void (*irq_setup)(void);
Index: arch/mips/ddb5xxx/ddb5476/vrc5476_irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5476/vrc5476_irq.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5476/vrc5476_irq.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5476/vrc5476_irq.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -12,6 +12,7 @@
  */
 #include <linux/init.h>
 #include <linux/interrupt.h>
+#include <linux/irq.h>
 #include <linux/types.h>
 #include <linux/ptrace.h>
 
@@ -81,7 +82,6 @@
 asmlinkage void
 vrc5476_irq_dispatch(struct pt_regs *regs)
 {
-	extern unsigned int do_IRQ(int irq, struct pt_regs *regs);
 	extern void spurious_interrupt(void);
 
 	u32 mask;
Index: arch/mips/ddb5xxx/ddb5477/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5477/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5477/Makefile	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5477/Makefile	4 Aug 2004 01:25:49 -0000	1.2
@@ -12,8 +12,7 @@
 
 obj-y	 += int-handler.o irq.o irq_5477.o setup.o pci.o pci_ops.o lcd44780.o
 
-obj-$(CONFIG_DEBUG) 		+= debug.o
-obj-$(CONFIG_REMOTE_DEBUG)	+= kgdb_io.o
-obj-$(CONFIG_BLK_DEV_INITRD)	+= ramdisk.o
+obj-$(CONFIG_RUNTIME_DEBUG) 	+= debug.o
+obj-$(CONFIG_KGDB)		+= kgdb_io.o
 
 include $(TOPDIR)/Rules.make
Index: arch/mips/ddb5xxx/ddb5477/debug.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5477/debug.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5477/debug.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5477/debug.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -56,8 +56,8 @@
 void vrc5477_show_int_regs()
 {
 	jsun_show_regs("interrupt registers", int_regs);
-	printk("CPU CAUSE = %08x\n", read_32bit_cp0_register(CP0_CAUSE));
-	printk("CPU STATUS = %08x\n", read_32bit_cp0_register(CP0_STATUS));
+	printk("CPU CAUSE = %08x\n", read_c0_cause());
+	printk("CPU STATUS = %08x\n", read_c0_status());
 }
 static Register pdar_regs[] = {
         {"DDB_SDRAM0", DDB_BASE + DDB_SDRAM0},
Index: arch/mips/ddb5xxx/ddb5477/int-handler.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5477/int-handler.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5477/int-handler.S	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5477/int-handler.S	4 Aug 2004 01:25:49 -0000	1.2
@@ -14,6 +14,7 @@
 #include <asm/addrspace.h>
 #include <asm/regdef.h>
 #include <asm/stackframe.h>
+#include <asm/ddb5xxx/ddb5477.h>
 
 /*
  * first level interrupt dispatcher for ocelot board -
@@ -55,20 +56,20 @@
 	j	ret_from_irq
 
 ll_cputimer_irq:
-	li	a0, 7
+	li	a0, CPU_IRQ_BASE + 7
 	move	a1, sp
 	jal	do_IRQ
 	j	ret_from_irq
 
 
 ll_cpu_ip0:
-	li	a0, 0
+	li	a0, CPU_IRQ_BASE + 0
 	move	a1, sp
 	jal	do_IRQ
 	j	ret_from_irq
 
 ll_cpu_ip1:
-	li	a0, 1
+	li	a0, CPU_IRQ_BASE + 1
 	move	a1, sp
 	jal	do_IRQ
 	j	ret_from_irq
Index: arch/mips/ddb5xxx/ddb5477/irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5477/irq.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5477/irq.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5477/irq.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -13,9 +13,11 @@
 #include <linux/config.h>
 #include <linux/init.h>
 #include <linux/interrupt.h>
+#include <linux/irq.h>
 #include <linux/types.h>
 #include <linux/ptrace.h>
 
+#include <asm/i8259.h>
 #include <asm/system.h>
 #include <asm/mipsregs.h>
 #include <asm/debug.h>
@@ -71,7 +73,6 @@
 	ddb_out32(pci, reg_value);
 }
 
-extern void init_i8259_irqs (void);
 extern void vrc5477_irq_init(u32 base);
 extern void mips_cpu_irq_init(u32 base);
 extern asmlinkage void ddb5477_handle_int(void);
@@ -90,8 +91,8 @@
 	ddb_out32(DDB_INTCTRL2, 0);
 	ddb_out32(DDB_INTCTRL3, 0);
 
-	clear_cp0_status(0xff00);
-	set_cp0_status(0x0400);
+	clear_c0_status(0xff00);
+	set_c0_status(0x0400);
 
 	/* setup PCI interrupt attributes */
 	set_pci_int_attr(PCI0, INTA, ACTIVE_LOW, LEVEL_SENSE);
@@ -164,8 +165,6 @@
 asmlinkage void
 vrc5477_irq_dispatch(struct pt_regs *regs)
 {
-	extern unsigned int do_IRQ(int irq, struct pt_regs *regs);
-
 	u32 intStatus;
 	u32 bitmask;
 	u32 i;
@@ -176,7 +175,7 @@
 	db_assert(ddb_in32(DDB_NMISTAT) == 0);
 
 	if (ddb_in32(DDB_INT1STAT) != 0) {
-#if defined(CONFIG_DEBUG)
+#if defined(CONFIG_RUNTIME_DEBUG)
 		vrc5477_show_int_regs();
 #endif
 		panic("error interrupt has happened.");
Index: arch/mips/ddb5xxx/ddb5477/pci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5477/pci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5477/pci.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5477/pci.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -166,10 +166,6 @@
 	}
 }
 
-#if defined(CONFIG_DEBUG)
-extern void jsun_scan_pci_bus(void);
-extern void jsun_assign_pci_resource(void);
-#endif
 void ddb_pci_reset_bus(void)
 {
 	u32 temp;
@@ -204,6 +200,33 @@
 {
 }
 
+/* 
+ * fixup baseboard AMD chip so that tx does not underflow.
+ *	bcr_18 |= 0x0800
+ * This sets NOUFLO bit which makes tx not start until whole pkt 
+ * is fetched to the chip.
+ */
+#define	PCNET32_WIO_RDP         0x10
+#define	PCNET32_WIO_RAP		0x12
+#define	PCNET32_WIO_RESET       0x14
+#define	PCNET32_WIO_BDP         0x16
+void __init fix_amd_lance(struct pci_dev *dev)
+{
+	unsigned long ioaddr;
+	u16 temp;
+
+	ioaddr=pci_resource_start(dev, 0);
+
+	inw(ioaddr + PCNET32_WIO_RESET);		/* reset chip */
+
+ 	/* bcr_18 |= 0x0800 */
+	outw (18, ioaddr + PCNET32_WIO_RAP);
+	temp = inw (ioaddr + PCNET32_WIO_BDP);
+	temp |= 0x0800;
+	outw (18, ioaddr + PCNET32_WIO_RAP);
+	outw (temp, ioaddr + PCNET32_WIO_BDP);
+}
+
 void __init pcibios_fixup(void)
 {
 	if (mips_machtype == MACH_NEC_ROCKHOPPERII) {
@@ -241,6 +264,10 @@
 				pci_read_config_byte(dev, 0x41, &old);
 				pci_write_config_byte(dev, 0x41, old | 0xd0);
 			}
+
+			if (dev->vendor == PCI_VENDOR_ID_AMD && 
+					dev->device == PCI_DEVICE_ID_AMD_LANCE) 
+				fix_amd_lance(dev);
 		}
 
 	}
Index: arch/mips/ddb5xxx/ddb5477/setup.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/ddb5xxx/ddb5477/setup.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/ddb5xxx/ddb5477/setup.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/ddb5xxx/ddb5477/setup.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -43,12 +43,10 @@
 #include "lcd44780.h"
 
 
-// #define	USE_CPU_COUNTER_TIMER	/* whether we use cpu counter */
+#define	USE_CPU_COUNTER_TIMER	/* whether we use cpu counter */
 
-#ifndef USE_CPU_COUNTER_TIMER
 #define	SP_TIMER_BASE			DDB_SPT1CTRL_L
 #define	SP_TIMER_IRQ			VRC5477_IRQ_SPT1
-#endif
 
 static int bus_frequency = CONFIG_DDB5477_BUS_FREQUENCY*1000;
 
@@ -88,38 +86,36 @@
 	unsigned char c;
 	unsigned int t1, t2;
 	unsigned i;
-	unsigned preset_freq[]={
-		0,        83330000, 100000000, 124000000,133300000, 0xffffffff};
 
 	ddb_out32(SP_TIMER_BASE, 0xffffffff);
 	ddb_out32(SP_TIMER_BASE+4, 0x1);
 	ddb_out32(SP_TIMER_BASE+8, 0xffffffff);
-	c= *(volatile unsigned char*)rtc_base;
-	for(i=0; (i<100000000) && (c == *(volatile unsigned char*)rtc_base); i++);
 
+	/* check if rtc is running */
+	c= *(volatile unsigned char*)rtc_base;
+	for(i=0; (c == *(volatile unsigned char*)rtc_base) && (i<100000000); i++);
 	if (c == *(volatile unsigned char*)rtc_base) {
 		printk("Failed to detect bus frequency.  Use default 83.3MHz.\n");
 		return 83333000;
 	}
 
-	/* we are now at the turn of 1/100th second */
-	t1 = ddb_in32(SP_TIMER_BASE+8);
-
 	c= *(volatile unsigned char*)rtc_base;
 	while (c == *(volatile unsigned char*)rtc_base);
+	/* we are now at the turn of 1/100th second, if no error. */
+	t1 = ddb_in32(SP_TIMER_BASE+8);
 
-	/* we are now at the turn of another 1/100th second */
-	t2 = ddb_in32(SP_TIMER_BASE+8);
-	ddb_out32(SP_TIMER_BASE+4, 0x0);	/* disable it again */
-	freq = (t1 - t2)*100;
+	for (i=0; i< 10; i++) {
+		c= *(volatile unsigned char*)rtc_base;
+		while (c == *(volatile unsigned char*)rtc_base);
+		/* we are now at the turn of another 1/100th second */
+		t2 = ddb_in32(SP_TIMER_BASE+8);
+	}
 
-	/* find the nearest preset freq */
-	for (i=0; freq > preset_freq[i+1]; i++);
-	if ((freq - preset_freq[i]) >= (preset_freq[i+1]-freq))
-		i++;
+	ddb_out32(SP_TIMER_BASE+4, 0x0);	/* disable it again */
 
-	printk("DDB bus frequency detection : %d -> %d\n", freq, preset_freq[i]);
-	return preset_freq[i];
+	freq = (t1 - t2)*10;
+	printk("DDB bus frequency detection : %u \n", freq);
+	return freq;
 }
 
 extern void rtc_ds1386_init(unsigned long base);
@@ -142,11 +138,11 @@
 		bus_frequency = detect_bus_frequency(rtc_base);
 	}
 
-	/* mips_counter_frequency is 1/2 of the cpu core freq */
-	i =  (read_32bit_cp0_register(CP0_CONFIG) >> 28 ) & 7;
-	if ((mips_cpu.cputype == CPU_R5432) && (i == 3))
+	/* mips_hpt_frequency is 1/2 of the cpu core freq */
+	i =  (read_c0_config() >> 28 ) & 7;
+	if ((current_cpu_data.cputype == CPU_R5432) && (i == 3))
 		i = 4;
-	mips_counter_frequency = bus_frequency*(i+4)/4;
+	mips_hpt_frequency = bus_frequency*(i+4)/4;
 }
 
 extern int setup_irq(unsigned int irq, struct irqaction *irqaction);
@@ -158,10 +154,6 @@
         /* we are using the cpu counter for timer interrupts */
 	setup_irq(CPU_IRQ_BASE + 7, irq);
 
-        /* to generate the first timer interrupt */
-        count = read_32bit_cp0_register(CP0_COUNT);
-        write_32bit_cp0_register(CP0_COMPARE, count + 1000);
-
 #else
 
 	/* if we use Special purpose timer 1 */
@@ -172,8 +164,6 @@
 #endif
 }
 
-void __init bus_error_init(void) { /* nothing */ }
-
 static void ddb5477_board_init(void);
 extern void ddb5477_irq_setup(void);
 
Index: arch/mips/dec/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/dec/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/dec/Makefile	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/dec/Makefile	4 Aug 2004 01:25:49 -0000	1.2
@@ -12,9 +12,10 @@
 
 all: dec.o
 
-export-objs := setup.o wbflush.o
-obj-y	 := int-handler.o ioasic-irq.o kn02-irq.o reset.o rtc-dec.o setup.o \
-	time.o
+export-objs	:= rtc-dec.o setup.o wbflush.o
+
+obj-y		:= ecc-berr.o int-handler.o ioasic-irq.o kn02-irq.o reset.o \
+		   rtc-dec.o setup.o time.o
 
 obj-$(CONFIG_PROM_CONSOLE)	+= promcon.o
 obj-$(CONFIG_CPU_HAS_WB)	+= wbflush.o
Index: arch/mips/dec/int-handler.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/dec/int-handler.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/dec/int-handler.S	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/dec/int-handler.S	4 Aug 2004 01:25:49 -0000	1.2
@@ -2,7 +2,7 @@
  * arch/mips/dec/int-handler.S
  *
  * Copyright (C) 1995, 1996, 1997 Paul M. Antoine and Harald Koerfgen
- * Copyright (C) 2000, 2001, 2002  Maciej W. Rozycki
+ * Copyright (C) 2000, 2001, 2002, 2003  Maciej W. Rozycki
  *
  * Written by Ralf Baechle and Andreas Busse, modified for DECStation
  * support by Paul Antoine and Harald Koerfgen.
@@ -132,19 +132,23 @@
 		 */
 		mfc0	t0,CP0_CAUSE		# get pending interrupts
 		mfc0	t1,CP0_STATUS
+#ifdef CONFIG_MIPS32
 		lw	t2,cpu_fpu_mask
+#endif
 		andi	t0,ST0_IM		# CAUSE.CE may be non-zero!
 		and	t0,t1			# isolate allowed ones
 
 		beqz	t0,spurious
 
+#ifdef CONFIG_MIPS32
 		 and	t2,t0
 		bnez	t2,fpu			# handle FPU immediately
+#endif
 
 		/*
 		 * Find irq with highest priority
 		 */
-		 la	t1,cpu_mask_nr_tbl
+		 PTR_LA	t1,cpu_mask_nr_tbl
 1:		lw	t2,(t1)
 		nop
 		and	t2,t0
@@ -161,14 +165,16 @@
 		 nop
 		jr	a0
 						# a trick to save a branch:
-		 lui	t2,KN03_IOASIC_BASE>>16	# upper part of IOASIC Address
+		 lui	t2,(KN03_IOASIC_BASE>>16)&0xffff
+						# upper part of IOASIC Address
 
 /*
  * Handle "IRQ Controller" Interrupts
  * Masked Interrupts are still visible and have to be masked "by hand".
  */
 		FEXPORT(kn02_io_int)		# 3max
-		lui	t0,KN02_CSR_ADDR>>16	# get interrupt status and mask
+		lui	t0,(KN02_CSR_BASE>>16)&0xffff
+						# get interrupt status and mask
 		lw	t0,(t0)
 		nop
 		andi	t1,t0,KN02_IRQ_ALL
@@ -176,11 +182,12 @@
 		 srl	t0,16			# shift interrupt mask
 
 		FEXPORT(kn02xa_io_int)		# 3min/maxine
-		lui	t2,KN02XA_IOASIC_BASE>>16 # upper part of IOASIC Address
+		lui	t2,(KN02XA_IOASIC_BASE>>16)&0xffff
+						# upper part of IOASIC Address
 
 		FEXPORT(kn03_io_int)		# 3max+ (t2 loaded earlier)
-		lw	t0,SIR(t2)		# get status: IOASIC isr
-		lw	t1,SIMR(t2)		# get mask:   IOASIC isrm
+		lw	t0,IO_REG_SIR(t2)	# get status: IOASIC sir
+		lw	t1,IO_REG_SIMR(t2)	# get mask:   IOASIC simr
 		nop
 
 1:		and	t0,t1			# mask out allowed ones
@@ -190,7 +197,7 @@
 		/*
 		 * Find irq with highest priority
 		 */
-		 la	t1,asic_mask_nr_tbl
+		 PTR_LA	t1,asic_mask_nr_tbl
 2:		lw	t2,(t1)
 		nop
 		and	t2,t0
@@ -263,9 +270,11 @@
 		j	ret_from_irq
 		 nop
 
+#ifdef CONFIG_MIPS32
 fpu:
 		j	handle_fpe_int
 		 nop
+#endif
 
 spurious:
 		j	spurious_interrupt
Index: arch/mips/dec/ioasic-irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/mips/dec/ioasic-irq.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/mips/dec/ioasic-irq.c	22 Jul 2004 19:49:14 -0000	1.1
+++ arch/mips/dec/ioasic-irq.c	4 Aug 2004 01:25:49 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *	DEC I/O ASIC interrupts.
  *
- *	Copyright (c) 2002  Maciej W. Rozycki
+ *	Copyright (c) 2002, 2003  Maciej W. Rozycki
  *
  *	This program is free software; you can redistribute it and/or
  *	modify it under the terms of the GNU General Public License
@@ -30,18 +30,18 @@
 {
 	u32 simr;
 
-	simr = ioasic_read(SIMR);
+	simr = ioasic_read(IO_REG_SIMR);
 	simr |= (1 << (irq - ioasic_irq_base));
-	ioasic_write(SIMR, simr);
+	ioasic_write(IO_REG_SIMR, simr);
 }
 
 static inline void mask_ioasic_irq(unsigned int irq)
 {
 	u32 simr;
 
-	simr = ioasic_read(SIMR);
+	simr = ioasic_read(IO_REG_SIMR);
 	simr &= ~(1 << (irq - ioasic_irq_base));
-	ioasic_write(SIMR, simr);
+	ioasic_write(IO_REG_SIMR, simr);
 }
 
 static inline void clear_ioasic_irq(unsigned int irq)
@@ -49,7 +49,7 @@
 	u32 sir;
 
 	sir = ~(1 << (irq - ioasic_irq_base));
-	ioasic_write(SIR, sir);
+	ioasic_write(IO_REG_SIR, sir);
 }
 
 static inline void enable_ioasic_irq(unsigned int irq)
@@ -93,17 +93,14 @@
 		enable_ioasic_irq(irq);
 }
 
-#define set_ioasic_affinity NULL
-
 static struct hw_interrupt_type ioasic_irq_type = {
-	"IO-ASIC",
-	startup_ioasic_irq,
-	shutdown_ioasic_irq,
-	enable_ioasic_irq,
-	disable_ioasic_irq,
-	ack_ioasic_irq,
-	end_ioasic_irq,
-	set_ioasic_affinity,
+	.typename = "IO-ASIC",
+	.startup = startup_ioasic_irq,
+	.shutdown = shutdown_ioasic_irq,
+	.enable = enable_ioasic_irq,
+	.disable = disable_ioasic_irq,
+	.ack = ack_ioasic_irq,
+	.end = end_ioasic_irq,
 };
 
 
@@ -124,17 +121,14 @@
 	end_ioasic_irq(irq);
 }
 
-#define set_ioasic_dma_affinity set_ioasic_affinity
-
 static struct hw_interrupt_type ioasic_dma_irq_type = {
-	"IO-ASIC-DMA",
-	startup_ioasic_dma_irq,
-	shutdown_ioasic_dma_irq,
-	enable_ioasic_dma_irq,
-	disable_ioasic_dma_irq,
-	ack_ioasic_dma_irq,
-	end_ioasic_dma_irq,
-	set_ioasic_dma_affinity,
+	.typename = "IO-ASIC-DMA",
+	.startup = startup_ioasic_dma_irq,
+	.shutdown = shutdown_ioasic_dma_irq,
+	.enable = enable_ioasic_dma_irq,
+	.disable = disable_ioasic_dma_irq,
+	.ack = ack_ioasic_dma_irq,
+	.end = end_ioasic_dma_irq,
 };
 
 
@@ -143,7 +137,7 @@
 	int i;
 
 	/* Mask interrupts. */
-	ioasic_write(SIMR, 0);
+	ioasic_write(IO_REG_SIMR, 0);
 	fast_iob();
 
 	for (i = base; i < base + IO_INR_DMA; i++) {
